unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, StdCtrls, SMIBase, SMI2TXT, Grids, DBGrids;

type
  TfrmMain = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    SMImportFromText1: TSMImportFromText;
    btnImport: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Table1.DatabaseName := ExtractFilePath(Application.ExeName);
  Table1.Open
end;

procedure TfrmMain.btnImportClick(Sender: TObject);
begin
  {1. specify text file settings}
  SMImportFromText1.SourceFileName := ExtractFilePath(Application.ExeName) + 'values.txt';
  SMImportFromText1.Fixed := False;
  SMImportFromText1.FieldDelimiter := fdSemicolon;
  SMImportFromText1.TextQualifier := tqNone;

  {2. define the mappings}
  SMImportFromText1.Mappings.Clear;
  SMImportFromText1.Mappings.Add('ID=Field1');
  SMImportFromText1.Mappings.Add('Value=Field2');

  {3. specify the destination and "search" criteria}
  SMImportFromText1.Dataset := Table1;
  SMImportFromText1.DatasetKeys := 'ID';
  SMImportFromText1.Mode := imAppendUpdate;

  {start the update process}
  SMImportFromText1.Execute
end;

end.
