unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, Grids, DBGrids, SMIBase, SMI2TXT, StdCtrls;

type
  TfrmMain = class(TForm)
    dSrcLog: TDataSource;
    tblLog: TTable;
    dbgLog: TDBGrid;
    btnAbout: TButton;
    SMImportFromText1: TSMImportFromText;
    btnImport: TButton;
    lblURL: TLabel;
    MemoDescription: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnImportClick(Sender: TObject);
    procedure SMImportFromText1ErrorEvent(Sender: TObject;
      Error: Exception; var Abort: Boolean);
    procedure lblURLClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
{$R winxp.res}
uses ShellAPI;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Application.ShowHint := True;
  
  {open the table from application directory}
  tblLog.DatabaseName := ExtractFilePath(Application.ExeName);
  tblLog.Open;
end;

procedure TfrmMain.btnAboutClick(Sender: TObject);
begin
  SMImportFromText1.AboutSMI
end;

procedure TfrmMain.btnImportClick(Sender: TObject);
begin
  {file settings}
  SMImportFromText1.Fixed := False;
  SMImportFromText1.TextQualifier := tqNone;
  SMImportFromText1.FieldDelimiter := fdSemicolon;
  SMImportFromText1.RecordSeparator := rsCRLF;
  SMImportFromText1.SourceFileName := ExtractFilePath(Application.ExeName) + 'log.csv';

  {mappings}
  SMImportFromText1.Mappings.Clear;
  SMImportFromText1.Mappings.Add('DTOPEN=Field1');
  SMImportFromText1.Mappings.Add('DTCLOSE=Field2');
  SMImportFromText1.Mappings.Add('ACTION=Field3');
  SMImportFromText1.Mappings.Add('USERID=yourUserID'); //value from parameter (end-user)
  SMImportFromText1.Mappings.Add('ADDED=CurrentDate'); //value from parameter (hidden from end-user)

  {load only lines from CSV which are "valid" (end-user values for parameters)}
  SMImportFromText1.LoadCondition.LoadWhen := '(LoadFiltered = False) OR (IsNull(StartDate)) OR (StartDate <= Field1)';
//  SMImportFromText1.LoadCondition.LoadWhen := '(LoadFiltered = False) OR IsNull(StartDate) OR (StartDate <= Field1)';

  {start the load process}
  SMImportFromText1.Mode := imAppend;
  SMImportFromText1.Execute;
end;

procedure TfrmMain.SMImportFromText1ErrorEvent(Sender: TObject;
  Error: Exception; var Abort: Boolean);
begin
  if (MessageDlg(Error.Message + #13#10 + 'To continue the import?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    Abort := False
  else
    Abort := True
end;

procedure TfrmMain.lblURLClick(Sender: TObject);
begin
  ShellExecute(0, 'open', 'http://www.scalabium.com/smi', nil, nil, SW_SHOWNORMAL);
end;

end.
